#!/usr/bin/php
<?php
$_SERVER['SHELL'] = "/bin/sh";

include "/usr/local/opmon/etc/config.php";

$mod = "EXTERNAL";
set_logged_user("opmonadmin");

/* wait for ~7seconds to see if opmon load objects */
function wait_for_load() {

	$wait = 0;
	while($wait < 15) {

		if (objects_are_loaded())
			return TRUE;

		usleep(500000);
		$wait++;
	}

	return FALSE;

}

function main() {

	$options = getopt("s:i:h");

	if (isset($options['h']))
		usage();

	if (!isset($options['s']) && !isset($options['i']))
		usage();

	if (wait_for_load() === FALSE) {
		print "OK - OpMon is still loading objects\n";
		exit(OK);
	}

	$myscat = false;
	if (isset($options['s'])) {

		$scats = get_scats();
		foreach($scats as $s) {
			if (utf8_decode($s->name) == $options['s']) {
				$myscat = $s;
				break;
			}

		}

	} elseif(isset($options['i'])) {
		if (!is_numeric($options['i'])){
		    die("id invalido\n");
		}
		$myscat = get_scat_by_id($options['i']);
	}

	if ($myscat == false) {
		$query = "select * from scats where id={$options['i']}";
		$result = do_query($query,DBOPMON,OPDB_FETCH_OBJ);
		if ($result->RecordCount() != 1) {
		    print "UNKNOWN - Impossivel encontrar o servico {$options['s']}\n";    
		} else {		
		    print "UNKNOWN - Sem permissao de acesso a um ou mais componentes do catalogo {$options['s']}\n";
		}
		$result->Close();
		exit(UNKNOWN);
	}

	$exit_code = $myscat->get_status();
	
	if ($exit_code == OK) {
		print "OK - Servico do catalogo em funcionamento normal.\n";
		exit(OK);
	}

	$plugin_output = "%d elementos do servico com problema: %s\n";
	$prbl_elems = 0;
	$problems = array();
	foreach($myscat->levels as $level => $elements) {

		foreach($elements as $e) {

			if ($e->service_id === null) { // scat inside scat
				$s = get_scat_by_id($e->host_id);
				if ($s === false) {
					$problems[] = "Unable to locate scat by id $e->host_id";
				}

			} else {

				$s = get_service_by_id($e->host_id,$e->service_id);
				if ($s === false) {
					$problems[] = "Unable to locate service({$e->host_id},{$e->service_id})";
				}

			}

			$status = $s->get_status();
			if ($e->service_id === null) { // scat inside scat
				$current_state = $status;
				$desc = "{$s->name}";
			} else {
				$current_state = $status->current_state;
				$desc = "{$status->host_name}({$status->service_description})";
			}

			if ($current_state != OK) {

				$prbl_elems++;

				switch($current_state) {

				case WARNING:
					$desc .= " WARNING";
					break;

				case CRITICAL:
					$desc .= " CRITICAL";
					break;

				default:
					$desc .= " UNKNOWN";
					break;
				}

				$problems[] = $desc;
			}
		}
	}

	print sprintf($plugin_output, $prbl_elems, implode(",",$problems));
	exit($exit_code);
}

function usage() {
	print "Usage: ./check_scat_status.php [-s <scat name>] [-i <scat id>]\n";
	exit(UNKNOWN);
}

main();

?>
